Statslog = LibStub("AceAddon-3.0"):NewAddon("Statslog", "AceEvent-3.0",  "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("Statslog")

function Statslog:OnInitialize()
	self.db = LibStub('AceDB-3.0'):New('StatslogDB', self:CreateDefaults(), true)
	AceConfig = LibStub("AceConfigDialog-3.0")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Statslog", self:CreateOptions())
	AceConfig:AddToBlizOptions("Statslog", "Statslog")
	Statslog:RegisterChatCommand('printstats', 'PrintDefStats')
end

function Statslog:OnEnable()

	if LoggingChat() then
		Statslog:Print(L["Chat is already being logged."])
	else
		LoggingChat(1);
		Statslog:Print(L["Chat logging is now enabled."])
	end
	
end

function Statslog:OnDisable()
end

function Statslog:PrintDefStats()
	local _, player_class = UnitClass("player")
	local player_level = UnitLevel("player")
	local _, strength, _, _ = UnitStat("player", 1)
	local _, agility, _, _ = UnitStat("player", 2)
	local dodge_pdr = GetDodgeChance()
	local parry_pdr = GetParryChance()
	local drating = GetCombatRating(CR_DODGE)
	local drating_bonus = GetCombatRatingBonus(CR_DODGE)
	local prating = GetCombatRating(CR_PARRY)
	local prating_bonus = GetCombatRatingBonus(CR_PARRY)
	local mastery = GetCombatRating(CR_MASTERY)
	local mastery_total = GetMasteryEffect()
	local block_pdr = GetBlockChance()

	-- STR AGI post_dodge post_parry dodge_rating pre_dodge parry_rating pre_parry mastery_rating post_mastery post_block
	local logstring = self.db.profile.tag .. " " .. strength .. " " .. agility
	logstring = logstring .. " " .. dodge_pdr .. " " .. parry_pdr
	logstring = logstring .. " " .. drating .. " " .. drating_bonus
	logstring = logstring .. " " .. prating .. " " .. prating_bonus
	logstring = logstring .. " " .. mastery .. " " .. mastery_total
	logstring = logstring .. " " .. block_pdr
	logstring = logstring .. " " .. player_class .. " " .. player_level

	local id, name = GetChannelName(self.db.profile.channel)
	if (id > 0 and name ~= nil) then
		SendChatMessage(logstring ,"CHANNEL" ,nil ,self.db.profile.channel)
	else
		Statslog:Print(L["Channel not found, select a correct channel ID in options."])
	end
end